unit Unit3;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, AdvUtil, Vcl.Grids, AdvObj, BaseGrid,
  AdvGrid, Vcl.StdCtrls, AdvEdit, VCL.TMSFNCTypes, VCL.TMSFNCUtils,
  VCL.TMSFNCGraphics, VCL.TMSFNCGraphicsTypes, VCL.TMSFNCCustomControl,
  VCL.TMSFNCCustomPicker, VCL.TMSFNCColorPicker, Vcl.Mask, AdvDropDown,
  AdvColorPickerDropDown, Vcl.ExtCtrls;

type
  TForm3 = class(TForm)
    SG1: TAdvStringGrid;
    AdvEdit1: TAdvEdit;
    Button1: TButton;
    Button2: TButton;
    AdvEdit2: TAdvEdit;
    CP1: TAdvColorPickerDropDown;
    Button3: TButton;
    TM1: TTimer;
    Button4: TButton;
    procedure FormCreate(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure CP1Select(Sender: TObject);
    procedure TM1Timer(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
  private
    { Private declarations }

    procedure ResetColor;

  public
    { Public declarations }
  end;

var
  Form3: TForm3;

implementation

{$R *.dfm}

procedure TForm3.ResetColor;
Begin
  if tm1.Enabled then tm1.Enabled:=False;
  for Var C: Integer:=0 to sg1.LastCol do
  begin
    for Var R: Integer:=0 to sg1.lastrow do
    begin
      sg1.Colors[C,R]:=clwhite;
    end;
  end;
End;

procedure TForm3.Button1Click(Sender: TObject);
begin
  Var C : Integer:=0;
  var R : Integer:=0;

  ResetColor;
  Randomize;

  for var I: Integer:=0 to 20 do
  begin
    C:=Random(5);
    R:=Random(10);
    sg1.Colors[C,R]:=clred;
  end;
end;

procedure TForm3.Button2Click(Sender: TObject);
begin
  if sg1.IsHiddenColumn(Sg1.ColumnPosition(2)) then sg1.UnHideColumn(Sg1.ColumnPosition(2))
  else
  sg1.HideColumn(Sg1.ColumnPosition(2));

end;

procedure TForm3.Button3Click(Sender: TObject);
begin
  if not tm1.Enabled then
  Begin
    ResetColor;
    tm1.Enabled:=True;
  End
  else
  tm1.Enabled:=False;
end;

procedure TForm3.Button4Click(Sender: TObject);
begin
  Resetcolor;
end;

procedure TForm3.CP1Select(Sender: TObject);
begin
  sg1.Colors[Sg1.ColumnPosition(advedit1.Value),advedit2.Value]:=CP1.Colors[cp1.ItemIndex].Color;
end;

procedure TForm3.FormCreate(Sender: TObject);
begin
  for Var i: integer:=0 to sg1.LastRow do
  begin
    for var c: integer:=0 to sg1.LastCol do
    begin
      sg1.Cells[c,i]:=inttostr(C) + ':' + inttostr(I);
    end;
  end;
  sg1.HideColumn(2);
end;

procedure TForm3.TM1Timer(Sender: TObject);
begin
  Var C : Integer:=0;
  var R : Integer:=0;
  Randomize;
  C:=Random(5);
  R:=Random(10);
  if sg1.Colors[C,R]=clred then sg1.Colors[C,R]:=clMaroon
  else
  if sg1.Colors[C,R]=clMaroon then sg1.Colors[C,R]:=clFuchsia
  else
  if sg1.Colors[C,R]=clFuchsia then sg1.Colors[C,R]:=clTeal
  else
  if sg1.Colors[C,R]=clteal then sg1.Colors[C,R]:=clWhite
  else
  sg1.Colors[C,R]:=clred;
end;

end.
